﻿using System;
using System.Xml;
using System.Net;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication2
{
    public class HtmlTextBlock : TextBlock
    {
        public static readonly DependencyProperty HtmlTextProperty = DependencyProperty.Register("HtmlText", typeof(string), typeof(HtmlTextBlock), new PropertyMetadata(String.Empty, new PropertyChangedCallback(_inlineChanged)));
        static void _inlineChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            HtmlTextBlock inst = d as HtmlTextBlock;
            inst.setHtmlText(e.NewValue as string);
        }
        public String HtmlText
        {
            get { return (String)this.GetValue(HtmlTextProperty); }
            set { this.SetValue(HtmlTextProperty, value); }
        }
        void setHtmlText(string htmlText)
        {
            this.Inlines.Clear();
            if (String.IsNullOrEmpty(htmlText))
                return;

            bool isBold = htmlText.StartsWith("<");
            foreach (string segment in htmlText.Split(new string[] { "<b>", "</b>" }, StringSplitOptions.RemoveEmptyEntries))
            {
                if (isBold)
                    Inlines.Add(new Italic(new Bold(new Run(segment))));
                else
                    Inlines.Add(new Run(segment));
                isBold = !isBold;
            }
        }
    }
}
