﻿using System;
using System.Xml;
using System.Net;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication2
{
    /// <summary>
    /// Window1.xaml の相互作用ロジック
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
        }

        
        string get_baseuri()
        {
            Microsoft.Win32.RegistryKey key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey(@"Software\Google\Google Desktop\API");
            string uri = key.GetValue("search_url") as string;
            key.Close();
            return uri;
        }

        string get_query(string query)
        {            
            StringBuilder sb = new StringBuilder();
            foreach(String item in query.Split(new char [] { ' ' }, StringSplitOptions.RemoveEmptyEntries))
            {
                sb.Append("+" + item);
            }
            string txt = sb.ToString().Trim(new char [] {'+'});

            string baseuri = get_baseuri();
            //http://127.0.0.1:4664/search&s=1ftR7c_hVZKYvuYS-RWnFHk91Z0?q=Google&format=xml
            return string.Format("{0}{1}&format=xml", get_baseuri(), txt);
        }

        string get_xml(string query)
        {
            WebRequest wreq = WebRequest.Create(get_query(query));
            WebResponse wres = wreq.GetResponse();
            using(Stream src = wres.GetResponseStream())
            using (StreamReader rdr = new StreamReader(src))
            {
                return rdr.ReadToEnd();
            }            
        }

        void query()
        {
            string xml = get_xml(_textbox.Text);
            Console.WriteLine(xml);        
            System.Xml.XmlDocument xdoc = new System.Xml.XmlDocument();
            xdoc.LoadXml(xml);
            XmlDataProvider prvd = new XmlDataProvider();
            prvd.Document = xdoc;
            this.DataContext = prvd;            
        }

        private void TextBox_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            switch (e.Key)
            { 
                case Key.Return:
                    query();
                    break;
                default:
                    return;
            }
            e.Handled = true;
        }
    }
}
